**==nterp.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
      SUBROUTINE NTERP2(E,IE,X)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c MultiWell: a code for chemical kinetics calculations.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c***********************************************************************
C
C	Calculate nearest element in Double Array of size Isize
c
c	'Double arrays' have two sections:
c		segment 1 consists of equally spaced (Egrain1) values ranging
c			from E=0 to Emax1
c		segment 2 consists of equally spaced values from E=0 to Emax2;
c			the spacing depends on the number of arrays elements
c			remaining: Isize-Emax1/Egrain1-1
c
c	E	= energy (units: cm-1)
c	Egrain1	= energy grain of lower segments in 'double arrays' (units: cm-1)
c	Egrain2	= energy grain of upper segments in 'double arrays' (units: cm-1)
c	Emax1	= maximum energy of 1st segment of double arrays (units: cm-1)
c	Emax2	= maximum energy of 2nd segment of double arrays (units: cm-1)
c	IE	= nearest element index
c	X	= fraction of element difference from IE (units: dimensionless)
c
c***********************************************************************
      IMPLICIT NONE
      INCLUDE 'declare1.inc'
      DOUBLE PRECISION E , X
      INTEGER IE
      SAVE 

! code modified to correctly interpolate k(E) array with Isize+imax1
! elements; imax1 of which are below the barrier

        if(E.le.Emax1)then
          IE=1+INT(E/Egrain1)+Imax1
          if(IE.lt.2) IE=2
          if(IE.gt.(2*Imax1-1)) IE=2*Imax1-1
          X=E/Egrain1-(IE-1.0)+Imax1
        else  
         IE = 2*imax1 + 1 + NINT(E/Egrain2)       ! Nearest integer
          if(IE.ge.Isize+Imax1) IE=Isize+Imax1-1
          if(IE.le.(2*Imax1+1)) IE=2*Imax1+2
         X = E/Egrain2 - (IE-2*imax1-1.0)
      end if
      RETURN
      END
