
      subroutine MaxVeff(Nt,beta,POT,c,De,re,mu,T,rmax,I2dGorin,V,
     &Veff,Eunits)

      Character POT*7, Eunits*4
      Double precision De,beta, re,derVeff,der2Veff,c, T
      Double precision I2dGorin,rmax,Veff,V,bet,mu
      INTEGER J, Nt
      Double precision a,aold,start

! Newton method 
      J=0
      start=re+0.5
      a=start
10    DO
 
      if(start.gt.9) then
       write(*,*) "**** FATAL: Unable to find maximum Veff(r). ****"
       stop
      endif

      J=J+1
      if(J.gt.1E6) then                     ! Max iterations  1.0E6
       write(*,*) "**** FATAL: Unable to find maximum Veff(r). ****"
       stop
      endif   
      derVeff=De*beta*(exp(-beta*(a-re))-exp(-2*beta*(a-re)))  ! Morse  V=De(1-exp(-beta0(r-re)))**2   beta0=SRQT(mu/De)
     &-(T/1.4388)/a

      if(POT.eq."VARSHNI") then   ! Varshni  V=De((1-re/r) exp(-beta(r**2-re**2)))**2   beta= 0.5(beta0-1/re)/re
      derVeff=2*De*re*(exp(-beta*(a**2-re**2)))*
     &(1-(re/a)*exp(-beta*(a**2-re**2)))*(2*beta+1/(a**2))-
     &2*(T/1.4388)/a
      endif

      if(POT.eq."sMORSE") then           ! Stiff Morse  V=De(1-exp(-beta(r-re)))**2   beta=beta0(1+C(r-re)**2)
       derVeff=2*De*beta*(2*c*a+1-2*c*re)*
     &(exp(-beta*(1+c*((a-re)**2))*(a-re))
     &-exp(-2*beta*(1+c*((a-re)**2))*(a-re)))-
     &2*(T/1.4388)/a
      endif


      der2Veff=(-De*beta**2)*(exp(-beta*(a-re))-2*
     &exp(-2*beta*(a-re)))+(T/1.4388)/(a**2)

      if(POT.eq."VARSHNI") then
      der2Veff=2*De*re*(-exp(-beta*(a**2-re**2))*
     &(4*(beta**2)*a-2/(a**3)-2*beta)+re*beta*exp(-2*beta*(a**2-re**2))*
     &(2/(a**2)+8*beta+3/(beta*(a**4))+4/(a**2)))+2*(T/1.4388)/(a**2)
      endif

      if(POT.eq."sMORSE") then
      der2Veff=4*De*beta*c*
     &((exp(-beta*(1+c*((a-re)**2))*(a-re))
     &-exp(-2*beta*(1+c*((a-re)**2))*(a-re))))-
     &2*De*(beta**2)*((2*a*c+1-2*c*re)**2)*
     &((exp(-beta*(1+c*((a-re)**2))*(a-re))
     &-2*exp(-2*beta*(1+c*((a-re)**2))*(a-re))))+
     &2*(T/1.4388)/(a**2)
      endif

      aold=a
      a=a-derVeff/der2Veff
      if(a.lt.re.OR.a.gt.100) then    !  re < a < 100
          start=start+1
          a=start 
          J=0
          goto 10
      endif
      if(ABS(aold-a).lt.1E-4.AND.ABS(derVeff).lt.1E-8) then   ! Convergence thresholds
         if(der2Veff.gt.0) then
          start=start+1
          a=start
          j=0
          goto 10
         endif
         rmax=a         
         I2dGorin=mu*(a**2)
         V=De*(1-exp(-beta*(a-re)))**2-De

         if(POT.eq."VARSHNI") then
         V=De*(1-(re/a)*exp(-beta*(a**2-re**2)))**2-De
         endif

         if(POT.eq."sMORSE") THEN
         V=De*(1-exp(-beta*(1+c*(a-re)**2)*(a-re)))**2-De
         endif

         Veff=V+(T/1.4388)
          IF ( Eunits.EQ.'KCAL' .OR. Eunits.EQ.'kcal' ) THEN
          V=V/349.76
          Veff=Veff/349.76
          ELSEIF ( Eunits.EQ.'KJOU' .OR. Eunits.EQ.'kjou' ) THEN
          V=V/83.59
          Veff=Veff/83.59
          ENDIF

          IF(POT.eq.'sMORSE') beta=beta*(1+c*(a-re)**2)
          return
      endif
      ENDDO   !10



      end subroutine

