      Subroutine thermochem

!  THERMOCHEMISTRY CALCULATION
      include 'declare.inc'
      Double precision Qvibration(NMax), Qtotal(Nmax), Qrotat(Nmax)
      Double precision CStop, HStop, SStop, QStop

         Dzpe = 0.0d+00
         DDelH = 0.0d+0
         Nflag = 0     ! no reaction
!     IF(vts.eq.1) Ns=3

      DO 200 i = 1 , Ns
            IF ( REPROD(i).EQ.REAC ) THEN
               DDelH = DDelH - DelH(i)          ! Delta H(0) for reaction
               Dzpe = Dzpe - zzpe(i)            ! Delta zpe for reaction
               Nflag = 1                        ! reaction
            ELSEIF ( REPROD(i).EQ.PROD .OR. REPROD(i).EQ.CTST ) THEN
                DDelH = DDelH + DelH(i)          ! Delta H(0) for reaction
                Dzpe = Dzpe + zzpe(i)            ! Delta zpe for reaction
                Nflag = 1                        ! reaction
            ENDIF
 200  CONTINUE
      
      IF ( Nflag .EQ. 1) THEN                   ! reaction thermo
      ENDIF
      
c
c	Thermodynamic functions at T
c

       Tdel = Tfrac*T(Temp)
       TT = T(Temp) - 2.d+00*Tdel
       DO 401 jj = 1 , 2
       TT = TT + Tdel         
         Qreac = 1.0d+00
         Qprod = 1.0d+00
         DO 250 i = 1 , Ns

            Qrotat(i)=1       
            Qvibration(i)=1       

            q = Qele(TT,i,Nele(i),Elev,gele,Cel,Sel,Hel)   ! electronic partition function
            Qtotal(i)=q
            Cp(i) =Rgas*Cel
            S(i) = Rgas*Sel
            H(i) = Rgas*Hel*TT        ! H(T)-H(0)
            IF ( Sunits.EQ.'ATM' ) THEN ! first part of translational part. fxn.
               q = q*(DBLE(Sopt(i))/DBLE(Sym(i)))*0.02560786*TT    ! (std. state= 1 atm)
            ELSEIF ( Sunits.EQ.'BAR' ) THEN
               q = q*(DBLE(Sopt(i))/DBLE(Sym(i)))*0.02594716*TT    ! (std. state= 1 bar)
            ELSEIF ( Sunits.EQ.'MCC' ) THEN
               q = q*(DBLE(Sopt(i))/DBLE(Sym(i)))*(1.879333E+20)   ! (std. state= 1 molecule/cc)
            ENDIF
            q = q*(AMU(i)*TT)**1.5    ! second part of translational part. fxn.

            ff = 3.6648556 - 1.5*log(AMU(i)) - 2.5*log(TT)
            H(i) = H(i) + 2.5*Rgas*TT        ! H(T)-H(0)
            Cp(i) = Cp(i) + 2.5*Rgas
            S(i) = S(i) + Rgas*((2.5-ff) + 
     &                 log(DBLE(Sopt(i))/DBLE(Sym(i))))
            IF ( N(i).NE.0 ) THEN                                   ! for non-monatomic species
               DO 210 j = 1 , N(i)
                  IF ( IDOF(i,j).EQ.VIB ) THEN  ! VIBRATION
                       qq = Qvib(TT,WE(i,j),ANH(i,j),NG(i,j),Cvib,Svib,
     &                    Hvib,zap)
                     q = q*qq
                     Qvibration(i)=Qvibration(i)*qq
                     Cp(i) = Cp(i) + Cvib*Rgas
                     H(i) = H(i) + Rgas*Hvib*TT        ! H(T)-H(0)
                     S(i) = S(i) + Rgas*Svib
                  ELSEIF ( IDOF(i,j).EQ.BOX ) THEN  ! PARTICLE IN A BOX
                     qq = Qbox(TT,WE(i,j),NG(i,j),Cpib,Spib,Hpib,zap)
                     q = q*qq
                     Cp(i) = Cp(i) + Cpib*Rgas
                     H(i) = H(i) + Rgas*Hpib*TT        ! H(T)-H(0)
                     S(i) = S(i) + Rgas*Spib
                  ELSEIF ( IDOF(i,j).EQ.GOR ) THEN   ! I2d Gorin
                     WE(i,j)=I2dGorin(Temp)
                      if (WE(i,j).gt.10) then 
                                                 ! CLASSICAL ROTOR
                       BB = 16.85763D+00/WE(i,j)  ! rotational constant (cm-1)
                       dim = NG(i,j)              ! rotor dimension
                       ss = INT(ANH(i,j))         ! rotor symmetry number (not included in over-all symmetry)
                       qq = Qrot(TT,BB,dim,ss,Crot,Srot,Hrot)
                       q = q*qq
                       Cp(i) = Cp(i) + Crot*Rgas
                       H(i) = H(i) + Hrot*Rgas*TT        ! H(T)-H(0)
                       S(i) = S(i) + Srot*Rgas
                      else
                                                ! QUANTUM ROTOR
                       BB = 16.85763D+00/WE(i,j)  ! rotational constant (cm-1)
                       dim = NG(i,j)
                                ! rotor dimension
                       ss = INT(ANH(i,j))
                                ! rotor symmetry number (not included in over-all symmetry)
                       qq = Qroq(TT,BB,dim,ss,Croq,Sroq,Hroq)
                       q = q*qq
                       Cp(i) = Cp(i) + Croq*Rgas
                       H(i) = H(i) + Hroq*Rgas*TT        ! H(T)-H(0)
                       S(i) = S(i) + Sroq*Rgas
                      endif
                  ELSEIF ( IDOF(i,j).EQ.FIT ) THEN   ! Hindrance
                       if (WE(i,j)*x.gt.10) then
                                                 ! CLASSICAL ROTOR
                       BB = 16.85763D+00/(WE(i,j)*x)  ! rotational constant (cm-1)
                       dim = NG(i,j)              ! rotor dimension
                       ss = INT(ANH(i,j))         ! rotor symmetry number (not included in over-all symmetry)
                       qq = Qrot(TT,BB,dim,ss,Crot,Srot,Hrot)
                       q = q*qq
                       Cp(i) = Cp(i) + Crot*Rgas
                       H(i) = H(i) + Hrot*Rgas*TT        ! H(T)-H(0)
                       S(i) = S(i) + Srot*Rgas
                      else
                                                ! QUANTUM ROTOR
                       BB = 16.85763D+00/(WE(i,j)*x)  ! rotational constant (cm-1)
                       dim = NG(i,j)
                                ! rotor dimension
                       ss = INT(ANH(i,j))
                                ! rotor symmetry number (not included in over-all symmetry)
                       qq = Qroq(TT,BB,dim,ss,Croq,Sroq,Hroq)
                       q = q*qq
                       Cp(i) = Cp(i) + Croq*Rgas
                       H(i) = H(i) + Hroq*Rgas*TT        ! H(T)-H(0)
                       S(i) = S(i) + Sroq*Rgas
                      endif
 

                  ELSEIF ( IDOF(i,j).EQ.ROT ) THEN
                                                ! CLASSICAL ROTOR
                     BB = 16.85763D+00/WE(i,j)  ! rotational constant (cm-1)
                     dim = NG(i,j)
                                ! rotor dimension
                     ss = INT(ANH(i,j))
                                ! rotor symmetry number (not included in over-all symmetry)
                     qq = Qrot(TT,BB,dim,ss,Crot,Srot,Hrot)
                     Qrotat(i)=Qrotat(i)*qq
                     q = q*qq
                     Cp(i) = Cp(i) + Crot*Rgas
                     H(i) = H(i) + Hrot*Rgas*TT        ! H(T)-H(0)
                     S(i) = S(i) + Srot*Rgas

                  ELSEIF ( IDOF(i,j).EQ.QRO ) THEN
                                                ! QUANTUM ROTOR
                     BB = 16.85763D+00/WE(i,j)  ! rotational constant (cm-1)
                     dim = NG(i,j)
                                ! rotor dimension
                     ss = INT(ANH(i,j))
                                ! rotor symmetry number (not included in over-all symmetry)
                     qq = Qroq(TT,BB,dim,ss,Croq,Sroq,Hroq)
                     q = q*qq
                     Cp(i) = Cp(i) + Croq*Rgas
                     H(i) = H(i) + Hroq*Rgas*TT        ! H(T)-H(0)
                     S(i) = S(i) + Sroq*Rgas

                  ELSEIF ( IDOF(i,j).EQ.HIN ) THEN                     ! HINDERED ROTOR
                     qq = Qhin(TT,B(i,j),VV(i,j),NG(i,j),NSIG(i,j),
     &                   Chin,Shin,Hhin,zap)
                     q = q*qq
                     Cp(i) = Cp(i) + Chin*Rgas
                     H(i) = H(i) + Hhin*Rgas*TT        ! H(T)-H(0)
                     S(i) = S(i) + Shin*Rgas
                  ELSEIF ( IDOF(i,j).EQ.TOP ) THEN                     ! SYMMETRIC TOP (QUANTUM)
                     BJ = 16.85763D+00/WE(i,j)    ! J-rotor rotational constant (cm-1)
                     BK = 16.85763D+00/ANH(i,j)   ! K-rotor rotational constant (cm-1)
                     ss = NG(i,j)                 ! rotor symmetry number (not included in over-all symmetry)
                     qq = QStop(TT,BJ,BK,ss,CStop,SStop,HStop)
                     q = q*qq
                     Cp(i) = Cp(i) + CStop*Rgas
                     H(i) = H(i) + HStop*Rgas*TT        ! H(T)-H(0)
                     S(i) = S(i) + SStop*Rgas
                  ENDIF
 210           CONTINUE
            ENDIF
            IF ( REPROD(i).EQ.REAC ) THEN
               Qreac = Qreac*q
            ELSEIF ( REPROD(i).EQ.PROD .OR. REPROD(i).EQ.CTST ) THEN
            Qprod = Qprod*q
            ENDIF
 250     CONTINUE
 
         IF ( Sunits.EQ.'ATM' ) THEN
            Sfac = 0.0
         ELSEIF ( Sunits.EQ.'BAR' ) THEN
            Sfac = Rgas*log(1.01325)
         ELSEIF ( Sunits.EQ.'MCC' ) THEN
            Sfac = Rgas*log(1.87915E+20/(0.02594*TT))
         ENDIF
 
         DSR = 0.0D+00
         DHR = Hdiff
!        if(vts.eq.1) DHR=DDelH*1000
         DCp = 0.0d+00
         DO 300 i = 1 , Ns
            IF ( REPROD(i).EQ.REAC ) THEN
               DSR = DSR - (Sfac+S(i))          ! Delta S for reaction
               DHR = DHR - H(i)                 ! Delta H for reaction
               DCp = DCp - Cp(i)                ! Delta Cp for reaction
            ELSEIF ( REPROD(i).EQ.PROD.OR.REPROD(i).EQ.CTST ) THEN
               DSR = DSR + (Sfac+S(i))          ! Delta S for reaction
               DHR = DHR + H(i)                 ! Delta H for reaction
               DCp = DCp + Cp(i)                ! Delta Cp for reaction
            ENDIF
 300     CONTINUE
 
         DG = (DSR - DHR/TT)/Rgas

         AK(jj) = exp(DG)                      ! Equilibrium constant

         IF ( Nctst .EQ. 1 ) THEN              ! Canonical TST rate constant
           AK(jj) = AK(jj)*2.0837D+10*TT       ! * kT/h
         ENDIF
     
 401  CONTINUE
      BB = -(LOG(AK(2)/AK(1)))*(T(Temp)**2)/Tdel          ! K       
      AA = AK(2)*exp( -BB / T(Temp) )                             ! 1/s
      
      end subroutine
