      Subroutine write_out

      include 'declare.inc'

      OPEN (UNIT=3,STATUS='UNKNOWN',FILE='thermo.out')          ! Full output

      DO Temp=1,Nt

      WRITE (3,99002) AVERSION , ADATE ,  AVERSION , ADATE
      DO  i=1,Ns
      WRITE (3,99014) MOLNAME(i)(1:lnblnk(MOLNAME(i))), TITLE(i)
      WRITE (3,99022)  (Elev(i,ne) , gele(i,ne) , ne=1,Nele(i))
      IF (Warning(i).eq.1) then 
        WRITE(3,*) "**** WARNING: Used 10 energy levels only. ****"
        WRITE(3,*)
      ENDIF
      
      IF ( N(i).GT.0 ) THEN
            DO 20 II = 1 , N(i)
               IF ( IDOF(i,II).EQ.VIB ) THEN                    ! VIBRATION
                  qq=Qvib(10.d+00,WE(i,II),ANH(i,II),NG(i,II),Cvib,Svib,
     &                    Hvib,zap)
                  WRITE (3,99010) MODE(i,II) , WOBS(i,II) , We(i,II) ,
     &                      ANH(i,II) , zap , NG(i,II)
               ELSEIF ( IDOF(i,II).EQ.BOX ) THEN                    ! PARTICLE IN A BOX
                  zap = W(i,II)
                  WRITE (3,99110) MODE(i,II) , WOBS(i,II) , W(i,II) ,
     &                      zap , NG(i,II)
               ELSEIF ( IDOF(i,II).EQ.ROT ) THEN                ! CLASSICAL ROTOR
                  BB = 16.85763D+00/AMOM(i,II)                  ! rotational constant (cm-1)
                  WRITE (3,99011) MODE(i,II) , WE(i,II) , ANH(i,II) ,
     &                            NG(i,II) , BB
               ELSEIF ( IDOF(i,II).EQ.QRO ) THEN                ! QUANTUM ROTOR
                  BB = 16.85763D+00/AMOM(i,II)                  ! rotational constant (cm-1)
                  WRITE (3,99012) MODE(i,II) , WE(i,II) , ANH(i,II) ,
     &                            NG(i,II) , BB
              ELSEIF (IDOF(i,II).EQ.GOR) THEN                   ! GORIN
               AMOM(i,II)=I2DGorin(Temp)
               WE(i,II)=AMOM(i,II)
               BB = 16.85763D+00/AMOM(i,II)
               if (AMOM(i,II).le.10)  THEN
                  WRITE (3,99012) MODE(i,II) , WE(i,II) , ANH(i,II) ,
     &                            NG(i,II) , BB
               ELSE
                  WRITE (3,99011) MODE(i,II) , WE(i,II) , ANH(i,II) ,
     &                            NG(i,II) , BB
               ENDIF
               ELSEIF ( IDOF(i,II).EQ.FIT) THEN                 ! HINDRANCE
                  AMOM(i,II) = WE(i,II)*gamma(Temp)
                  BB = 16.85763D+00/AMOM(i,II)                  ! rotational constant (cm-1)
                  if (AMOM(i,II).le.10)  THEN
                  WRITE (3,99012) MODE(i,II) , AMOM(i,II) , ANH(i,II) ,
     &                            NG(i,II) , BB
                    ELSE
                  WRITE (3,99011) MODE(i,II) , AMOM(i,II), ANH(i,II) ,
     &                            NG(i,II) , BB
                  endif
              ELSEIF ( IDOF(i,II).EQ.HIN ) THEN                ! HINDERED ROTOR (modified Troe method) INPUT MOMENT & VIB FREQ
                  qq=Qhin(10.d+00,B(i,II),VV(i,II),NG(i,II),NSIG(i,II),
     &                    Chin,Shin,Hhin,zap)
                  WRITE (3,99001) MODE(i,II) , W(i,II) , AMOM(i,II) ,
     &                NG(i,II) , NSIG(i,II) , B(i,II) , zap , VV(i,II)
               ELSEIF ( IDOF(i,II).EQ.TOP ) THEN               ! SYMMETRIC TOP
                  BJ = 16.85763D+00/WE(i,II)
                  BK = 16.85763D+00/ANH(i,II)
                  WRITE (3,99113) MODE(i,II) , WE(i,II) , 
     &                  BJ , ANH(i,II) , BK , NG(i,II)
              ENDIF
20          ENDDO
       ENDIF
       ENDDO
         WRITE (3,99016)
       DO i=1,Ns
         WRITE (3,99017) REPROD(i) , MOLNAME(i) ,
     &    AMU(i) , DelH(i) , zzpe(i) , Sym(i) , Sopt(i) ,
     &    Qele(298.15d+00,i,Nele(i),Elev,gele,Cel,Sel,Hel)
       ENDDO

      IF ( Nflag .EQ. 1) THEN                   ! reaction thermo
         WRITE (3,99021)
         WRITE (3,99020) DDelH, Dzpe
      ENDIF

     
      IF ( Eunits.EQ.'KCAL' ) THEN
         WRITE (3,99004) UNITS ,
     &   (MOLNAME(i)(1:lenstr(MOLNAME(i))),i=1,Ns)
      ELSEIF ( Eunits.EQ.'KJOU' ) THEN
         WRITE (3,99005) UNITS ,
     &   (MOLNAME(i)(1:lenstr(MOLNAME(i))),i=1,Ns)
      ENDIF

      IF (Nctst .EQ. 1 ) THEN                                  ! Canonical TST rate constant
         WRITE (3,99106) UNITS , 1-Nreac , (REPROD(i),i=1,Ns)
         WRITE (3,99103) (CAP,i=1,Ns)
      ELSE
         WRITE (3,99006) (REPROD(i),i=1,Ns)
         WRITE (3,99003) (CAP,i=1,Ns)
      ENDIF


      IF(hindrance.eq.0.AND.Gorin.eq.0) then 
        DO j=1,Nt
       WRITE (3,99007) T(j) , T_AK(j) , T_AA(j) ,T_BB(j) ,T_DSR(j) ,
     & T_DHR(j)/1000. , T_DCp(j) ,
     & (T_Sfac(j)+T_S(j,i),T_Cp(j,i),T_H(j,i)/1000., i=1,Ns)
        ENDDO
       CLOSE(3)
       STOP
      ENDIF

       WRITE (3,99007) T(temp) , T_AK(temp) , T_AA(temp) ,T_BB(temp) ,
     & T_DSR(temp) , T_DHR(temp)/1000. , T_DCp(temp) ,
     & (T_Sfac(temp)+T_S(temp,i),T_Cp(temp,i),T_H(temp,i)/1000., i=1,Ns)
         

 501    IF(Gorin.NE.0.OR.hindrance.ne.0) then
           if(hindrance.ne.0.AND.Gorin.eq.0) then
            write(*,*)
            write(3,*)
            write(*,*) "AUTOMATIC FITTING CALCULATION "
            write(3,*) "AUTOMATIC FITTING CALCULATION "
           endif

           if(hindrance.eq.0.AND.Gorin.ne.0) then
            write(*,*) 
            write(3,*) 
            write(*,*) "GORIN CALCULATION "
            write(3,*) "GORIN CALCULATION "
           endif

           if(hindrance.ne.0.AND.Gorin.ne.0) then
            write(*,*) 
            write(3,*) 
            write(*,*) "AUTOMATIC FITTING AND GORIN CALCULATION "
            write(3,*) "AUTOMATIC FITTING AND GORIN CALCULATION "
           endif

        write(*,*) 
        write(3,*)
        write(*,*) "T =",T(temp)
        write(3,*) "T =",T(temp) 
        ENDIF

        IF(Gorin.NE.0) then
         TypePOT=POT
         IF(POT.eq.'sMORSE') typePOT='Stiff MORSE'
         write(*,*) "   Potential:  ",TypePOT
         write(3,*) "   Potential:  ",TypePOT
         write(*,*) "   Frequency:  ", freq," cm-1"
         write(3,*) "   Frequency:  ", freq," cm-1"
!         write(*,*) "   2-D moment: ",I2d," amu A**2"
!         write(3,*) "   2-D moment: ",I2d," amu A**2"
         write(*,*) "   De Energy:  ", Deorig," ",Eunits
         write(3,*) "   De Energy:  ", Deorig," ",Eunits
         write(*,*) "   Equil. re:  ", re, " A"
         write(3,*) "   Equil. re:  ", re, " A"
         if(POT.eq.'VARSHNI') then
          write(*,*) "   Beta:       ", bet(temp), " A-2"
          write(3,*) "   Beta:       ", bet(temp), " A-2"
          else
          write(*,*) "   Beta:       ", bet(temp), " A-1"
          write(3,*) "   Beta:       ", bet(temp), " A-1"
          endif
         if(POT.eq.'sMORSE') then 
          write(*,*) "   stiff c:    ",c
          write(3,*) "   stiff c:    ",c
         endif 
         write(*,99023) I2dGorin(temp),rmax(temp)
         write(3,99023) I2dGorin(temp),rmax(temp)
         write(*,99024)  V(temp) , Eunits
         write(3,99024)  V(temp) , Eunits
         write(*,99025)  Veff(temp) , Eunits
         write(3,99025)  Veff(temp) , Eunits
        ENDIF

         IF(hindrance.ne.0) then
          write(*,*) "   Kexp       =  ",Kexp(temp)
          write(3,*) "   Kexp       =  ",Kexp(temp)
         IF(gamma(Temp).gt.1) then
         write(*,*) "**** WARNING: Gamma >1.0 (Maybe Kexp too big) ****"
         write(3,*) "**** WARNING: Gamma >1.0 (Maybe Kexp too big) ****"
         endif
        write(*,99026)  gamma(Temp), 1-gamma(Temp)**2                    ! Print Gamma and eta
        write(3,99026)  gamma(Temp), 1-gamma(Temp)**2                    ! Print Gamma and eta
        do i=1,hindrance
         write(*,99027) Weorig(i)*gamma(Temp)             !Print Optimized moment of inertia
         write(3,99027) WeOrig(i)*gamma(Temp)             !Print Optimized moment of inertia
        enddo
         ENDIF
       
       write(3,*) 
       write(3,*) 
       write(3,*) 

       ENDDO
       CLOSE(3)
 

99001 FORMAT (I5,2X,'Hind.Rot',2x,'Freq(har)=',F8.2,2x,'Mom=',F8.3,2x,
     &       'fold=',I2,2x,'symm=',I2,2x,'B=',F8.4,' cm-1',2x,
     &        'zpe(cm-1)=',F8.1,2x,'Uo=',F7.1,' cm-1')
99002 FORMAT (
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'//8x,
     &'                                John R. Barker'/8x,
     &'        Thermo-',A6,'           University of Michigan'/8x,
     &'                                Ann Arbor, MI 48109-2143'/8x,
     &'        ',A8,'                jrbarker@umich.edu'/8x,
     &'                                (734) 763 6239'//8x,
     &'      http://aoss.engin.umich.edu/multiwell/'//,
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'//8x,
     &'Citation:'//8x,
     &'a) MultiWell-',A6,' Software, ',A8,', designed and '/8x,
     &'   maintained by J. R. Barker with contributions from N. F.'/8x,
     &'   Ortiz, J. M. Preses, L. L. Lohr, A. Maranzana, and'/8x,
     &'   P. J. Stimac; University of Michigan, Ann Arbor, MI; '/8x,
     &'   http://aoss.engin.umich.edu/multiwell/.'//8x,
     &'b) J. R. Barker, Int. J. Chem. Kinetics, 33, 232-45 (2001).'//
     &'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     &%%%%%%%%%%%%%'/)
99003 FORMAT (8x,'T(K)',6x,'Kequil',4x,'A(T)',7x,'B(T)',4x,'DelS(rxn)',
     &        1x,'DelH(rxn)',1x,'DelCp(rxn)',5x,6(A27,1x))
99103 FORMAT (8x,'T(K)',6x,'k(T)  ',4x,'A(T)',7x,'B(T)',4x,'DelS(rxn)',
     &        1x,'DelH(rxn)',1x,'DelCp(rxn)',5x,6(A27,1x))
99004 FORMAT (//'THERMODYNAMIC QUANTITIES',10x,'Std. State = ',A12/,3x,
     &        'Entropy & Cp units: cal/K/mole'/3x,
     &        'DelS         units: cal/K/mole'/3x,
     &        '[H(T)-H(0)]  units: kcal/mole'/3x,
     &        'DelH         units: kcal/mole'//76x,6(7x,A10,11x))
99005 FORMAT (//'THERMODYNAMIC QUANTITIES',10x,'Std. State = ',A12/,3x,
     &        'Entropy & Cp units: J/K/mole'/3x,
     &        'DelS         units: J/K/mole'/3x,
     &        '[H(T)-H(0)]  units: kJ/mole'/3x,
     &        'DelH         units: kJ/mole'//76x,6(7x,A10,11x))
99006 FORMAT (25x,'Kequil = A*exp(B/T)',36x,6(7x,A4,17x))
99106 FORMAT (15x,'RATE k(T) = A*exp(B/T)',1x,
     &                    '(',A12,')**(',I2,') * sec-1',
     &        9x,6(7x,A4,17x))
99007 FORMAT (2x,f10.1,2(2x,1pe10.3),2x,0pf7.0,1x,0pf9.2,1x,0pf8.2, 
     &        1x,0pf10.2,3x,6(2x,0pf8.2,1x,f8.2,1x,f8.2)) 
99008 FORMAT (/)
99009 FORMAT (1x,f10.1,1x,I10,1x,f10.1,1x,I10,1x,f10.1)
99010  FORMAT (I5,2X,'Vibrator',2x,'Freq(obs)=',F8.2,2x,
     &        'Freq(har)=',F8.2,2x,'Anh(cm-1)=',F8.2,2X,
     &        'zpe(cm-1) =',F8.1,2x,'   g =',I2)
99110  FORMAT (I5,2X,'P-in-Box',2x,'Freq(obs)=',F8.2,2x,
     &        'Freq(har)=',F8.2,2x,
     &        'zpe(cm-1) =',F8.1,2x,'   g =',I2)
99011 FORMAT (I5,2X,'Clas.Rot',2x,'Moment   =',F8.2,2x,'Symm =',F4.0,2x,
     &        ' dim =',I2,2x,'B =',F8.4,' cm-1')
99012 FORMAT (I5,2X,'Quan.Rot',2x,'Moment   =',F8.2,2x,'Symm =',F4.0,2x,
     &        ' dim =',I2,2x,'B =',F8.4,' cm-1')
99113 FORMAT (I5,2X,'Symm Top',2x,'J-Moment =',F8.2,' BJ =',F8.4,' cm-1'
     &      ,2x,'K-Moment =',F8.2,' BK =',F8.4,' cm-1',2x,'Symm = ',I1)
99013 FORMAT (/'  No.  Freq(cm-1)  ANH(cm-1)      Degeneracy'/)
99114 FORMAT (A80)
99014 FORMAT (//A10, 5X, A80/)
99015 FORMAT (F10.1,4x,3(1pe10.3,4x),6(1pe10.3,1x))
99016 FORMAT (//'INPUT DATA: REACTANTS & PRODUCTS'//
     & ,' TYPE  NAME        Mol.Wt.   Enthalpy(O K)  ZPE(cm-1) Symmetry'
     & ,'  opt.isomers  Qele(298.15 K)')
99017 FORMAT (1x,A4,2x,A10,2(2x,F7.2),8x,F7.1,2I10,5x,F10.2)
99018 FORMAT (A100)
99019 FORMAT (1x,A10,2(5x,F10.2))
99020 FORMAT (5x,'NET (prod - react):',1x,F10.2,5x,F10.1)
99021 FORMAT (27x,'--------',5x,'----------')
99022 FORMAT (4X, 'Electronic Levels (degeneracies) ',/,
     &             10(10x,F10.2,1x,'cm-1 (',I2,')'/))
99023 FORMAT ('>>> Gorin external 2-D moment =',F9.4,' amu A**2 <<<',/
     &        '    Rmax       = ',F8.3,' A')
99024 FORMAT ('    V(Rmax)    = ',F8.3, ' ',4A)
99025 FORMAT ('    Veff(Rmax) = ',F8.3, ' ',4A)
99026 FORMAT ('    Gamma      =  ',F8.4,/
     &        '    Eta        =  ',F8.4)
99027 FORMAT ('    Moment * Gamma =',F8.3,' amu A**2')


      END subroutine

